/*

This demo is provided for a demonstration of each of the features
included with this library.  Refer to the documentation to find out
how any of this works.

V2 Release:
New item text object was added to Menu 2 to demonstrate the Update
procedure of the font object.

A basic input demo object has been included as well as a dynamic
one when you're on the map.  The latter is used for chatting.

Built-in Basic Host Menu Included (for multi-user testing)

Keyboard Input Support for Menu Objects

Few text objects with multi-line support.

Side Highlighting Cursor/Icon support.

Menu objects now support different modes, which are two are currently
in use for this demo.


There are a few comments provided in this demo source.

*/

world
	name = "SByIo Demo"
	maxx = 40
	maxy = 30
	maxz = 1
	view = "20x15"
	New()
		..()
		var/TextObj/MTO = new("Hello There!",Font3,"#0F0",0xFF,0)
		var/ItemTextObj/TITO1 = new("Clickable Teleporter!",Font3,"#00F",0xFF,0,"#FF0",null,null,"Teleport 19 25 1",null)
		MTO.SetMapLoc(20,25,1) // Make sure to go northeast about to find this message.
		TITO1.SetMapLoc(20,23,1)  // Just south of the above message.

var
	ptime = 0
	client/host
	FontObj
		Font1 = new(SBYIO_DEFAULTFONT,0,0,2,2) // This font object uses the default size of the default font with 2 pixel horizontal and vertical spacing.
		Font2 = new(SBYIO_DEFAULTFONT,24,16,4,2) // This font object uses the same font as the previous, but uses a different width, height, 4 pixel horizontal spacing, and 2 pixel vertical spacing.
		Font3 = new(SBYIO_DEFAULTFONT,24,24,2,2) // This font object uses the same font as the previous, but increases the width and height along with a 2 pixel horizontal and vertical spacing.
		Font4 = new(SBYIO_DEFAULTFONT,6,10,2,2)

turf
	icon = 'SimpleGrass.dmi'

mob
	icon = 'BasicGuy.dmi'

client
	var
		am = 0
		InputObj
			InputDemoIO
			HostDemoIO
		MenuObj
			MainMenuObj
			HostDemoMenuObj
			Menu2Obj
			NewMenuObj
			InputDemoMenuObj
		list
			CurrentMenu
			MainMenu = new()
			HostMenu = new()
			Menu2 = new()
			ItemTypesMenu = new()
			ViewMessageScreen = new()
			NewMenu = new()
			InputDemo = new()
			DataScreen = new()
			DataScreen2 = new()
	New()
		..()
		if(host == null)
			host = src
		mob.loc = null
		CreateMainMenu()
		CreateHostMenu()
		CreateMenu2()
		CreateItemTypesMenu()
		CreateViewMessageScreen()
		CreateNewMenu()
		CreateInputDemo()
		Intro() // View the intro that utilizes alpha effects.
	proc
		Intro()
			if(CurrentMenu != null)
				screen -= CurrentMenu
				sleep(5)
			var/TextObj/TO1 = new("Feature",Font3,"#FFF",0x00,0)
			var/TextObj/TO2 = new("Presentation",Font3,"#FFF",0x00,0)
			var/alpha = 0x00
			TO1.SetScreenLoc(8,0,9,0)
			TO2.SetScreenLoc(6,0,8,4)
			screen += TO1
			screen += TO2
			while(alpha < 0xFF)
				alpha += 0x0F
				TO1.SetAlpha(alpha)
				sleep(1)
			alpha = 0x00
			while(alpha < 0xFF)
				alpha += 0x0F
				TO2.SetAlpha(alpha)
				sleep(1)
			sleep(10)
			while(alpha > 0x00)
				alpha -= 0x0F
				TO1.SetAlpha(alpha)
				TO2.SetAlpha(alpha)
				sleep(1)
			sleep(5)
			screen -= TO1
			screen -= TO2
			CurrentMenu = MainMenu
			SetInputFocus(MainMenuObj)
			screen += CurrentMenu
		CreateMainMenu()
			var/TextObj/TO1 = new("SByIo",Font1,"#0F0",0xFF,0)
			var/TextObj/TO2 = new("Demo!",Font2,"#F00",0xFF,0)
			TO1.SetScreenLoc(9,24,13,0)
			TO2.SetScreenLoc(8,20,12,14)
			MainMenu += TO1
			MainMenu += TO2
			MainMenuObj = new(Font1,12,OUTLINE|HICON,"#FFF",0xFF,"#FFF","#FF0",null,'DemoCursor.dmi',0,0,MVSPACING)
			MainMenuObj.AddItem("Host Demo","EnterHostMenu")
			MainMenuObj.AddItem("Enter Map","EnterMap")
			MainMenuObj.AddItem("Enter Menu 2","EnterMenu2")
			MainMenuObj.AddItem("Enter Item Types","EnterItemTypesMenu")
			MainMenuObj.AddItem("View Message","ViewMessage")
			MainMenuObj.AddItem("New Menu","EnterNewMenu")
			MainMenuObj.AddItem("Input Demo","InputDemo")
			MainMenuObj.AddItem("View Intro","ViewIntro")
			MainMenuObj.AddItem("Exit",".quit")
			MainMenuObj.SetMenuLoc(8,24,10,0)
			MainMenu += MainMenuObj.GetMenuList()
		CreateHostMenu()
			var/TextObj/TO1 = new("Host Demo",Font3,"#00F",0xFF,0)
			var/TextObj/TO2 = new("Port:",Font1,"#FFF",0xFF,0)
			var/InputObj/IO = new("0",Font1,"#FFF",0xFF,5,NUM,OUTLINE|FILL,"#C0C0C0","#808080",null)
			TO1.SetScreenLoc(7,0,13,0)
			TO2.SetScreenLoc(7,0,12,2)
			IO.SetScreenLoc(8,20,12,0)
			HostMenu += TO1
			HostMenu += TO2
			HostMenu += IO
			HostDemoIO = IO
			HostDemoMenuObj = new(Font1,12,OUTLINE,"#FFF",0xFF,"#FFF","#FF0",null,null,0,0,MVSPACING)
			HostDemoMenuObj.AddItem("Host","Host")
			HostDemoMenuObj.AddItem("Return to Main Menu","EnterMainMenu")
			HostDemoMenuObj.SetMenuLoc(8,0,6,12)
			HostMenu += HostDemoMenuObj.GetMenuList()
		CreateMenu2()
			var/TextObj/TO1 = new("Menu Two",Font3,"#00F",0xFF,0)
			TO1.SetScreenLoc(8,0,12,20)
			Menu2 += TO1
			Menu2Obj = new(Font1,12,OUTLINE,"#F00",0xFF,"#F00","#FF0",null,null,0,0,MVSPACING)
			Menu2Obj.AddItem("Return to Main Menu","EnterMainMenu")
			Menu2Obj.AddItem("Secret Button!","ChangeHSpacing")
			Menu2Obj.AddItem("Secret Exit?",".quit")
			Menu2Obj.SetMenuLoc(8,24,10,0)
			Menu2 += Menu2Obj.GetMenuList()
		CreateItemTypesMenu()
			var/TextObj/TO1 = new("Fun with Item Types!",Font3,"#FF0",0xFF,0)
			var/ItemTextObj/ITO1 = new("Item Type 1",Font1,"#FFF",0xFF,0,"#F00",null,null,null,null)
			var/ItemTextObj/ITO2 = new("Item Type 2",Font1,"#FFF",0xFF,OUTLINE,"#FFF","#FF0",null,null,null)
			var/ItemTextObj/ITO3 = new("Item Type 3",Font1,"#FFF",0xFF,FILL,"#FFF",null,"#008",null,null)
			var/ItemTextObj/ITO4 = new("Item Type 4",Font1,"#FFF",0xFF,OUTLINE|FILL,"#FF0","#FFF","#00F",null,null)
			var/ItemTextObj/ITO5 = new("Item Type 5",Font1,"#FFF",0xFF,HICON,"#FFF",null,null,null,'DemoCursor.dmi')
			var/ItemTextObj/ITO6 = new("Return to Main Menu",Font2,"#F00",0xFF,0,"#00F",null,null,"EnterMainMenu",null)
			TO1.SetScreenLoc(3,16,12,20)
			ITO1.SetScreenLoc(8,26,10,0)
			ITO2.SetScreenLoc(8,24,9,0)
			ITO3.SetScreenLoc(8,24,8,0)
			ITO4.SetScreenLoc(8,24,7,0)
			ITO5.SetScreenLoc(8,16,6,0)
			ITO6.SetScreenLoc(3,0,5,0)
			ItemTypesMenu += TO1
			ItemTypesMenu += ITO1
			ItemTypesMenu += ITO2
			ItemTypesMenu += ITO3
			ItemTypesMenu += ITO4
			ItemTypesMenu += ITO5
			ItemTypesMenu += ITO6
		CreateViewMessageScreen()
			var/TextObj/TO1 = new({"Message From Bandock:
I see you have found the brand new text object.

That is very nice!"},Font1,"#FFF",0xFF,0)
			var/ItemTextObj/ITO = new("Return to Main Menu",Font1,"#00F",0xFF,OUTLINE,"#00F","#FF0",null,"EnterMainMenu",null)
			TO1.SetScreenLoc(4,0,12,0)
			ITO.SetScreenLoc(8,0,10,0)
			ViewMessageScreen += TO1
			ViewMessageScreen += ITO
		CreateNewMenu()
			var/TextObj/TO1 = new("New Menu!",Font3,"#0F0",0xFF,0)
			TO1.SetScreenLoc(7,16,13,0)
			NewMenu += TO1
			NewMenuObj = new(Font1,0,HICON,"#FFF",0xFF,"#FFF",null,null,'DemoCursor.dmi',1,12,MHSPACING)
			NewMenuObj.AddItem("Main Menu","EnterMainMenu")
			NewMenuObj.AddItem("Host","EnterHostMenu")
			NewMenuObj.AddItem("Quit",".quit")
			NewMenuObj.SetMenuLoc(7,16,10,0)
			NewMenu += NewMenuObj.GetMenuList()
		CreateInputDemo()
			var/TextObj/TO1 = new("Input Demo",Font3,"#00F",0xFF,0)
			var/TextObj/TO2 = new("Input:",Font1,"#FFF",0xFF,0)
			var/InputObj/IO = new(null,Font1,"#FFF",0xFF,25,TEXT,OUTLINE|FILL,"#C0C0C0","#808080",null)
			TO1.SetScreenLoc(7,0,13,0)
			TO2.SetScreenLoc(7,0,12,2)
			IO.SetScreenLoc(8,28,12,0)
			InputDemo += TO1
			InputDemo += TO2
			InputDemo += IO
			InputDemoIO = IO
			InputDemoMenuObj = new(Font1,12,OUTLINE,"#FFF",0xFF,"#FFF","#FF0",null,null,0,0,MVSPACING)
			InputDemoMenuObj.AddItem("Get Input Data","GetDataInput")
			InputDemoMenuObj.AddItem("Return to Main Menu","EnterMainMenu")
			InputDemoMenuObj.SetMenuLoc(8,0,6,12)
			InputDemo += InputDemoMenuObj.GetMenuList()
		ScreenOutput(source,data)
			var/TextObj/Msg = new("[data]",Font4,"#FF0",0xFF,0)
			Msg.layer = MOB_LAYER+1
			Msg.SetScreenLoc(2,0,4,0)
			for(var/mob/M in world)
				if(M.client && M.loc != null)
					if(source == world || source == M.client)
						var/epos = length(M.client.DataScreen)
						for(var/TextObj/DMsg in M.client.DataScreen)
							var/sy = 4
							var/spy = (epos * (DMsg.font.cheight + 2))
							while(spy >= 32)
								sy++
								spy -= 32
							DMsg.SetScreenLoc(2,0,sy,spy)
							epos--
						M.client.DataScreen += Msg
						M.client.screen += Msg
						spawn(50)
							M.client.DataScreen -= Msg
							M.client.screen -= Msg

	verb
		EnterHostMenu()
			if(host == src)
				screen -= CurrentMenu
				CurrentMenu = HostMenu
				screen += CurrentMenu
				ClearInputFocus()
			else
				alert("You must be the host to use this feature.")
		EnterMenu2()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = Menu2
			screen += CurrentMenu
		EnterMainMenu()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = MainMenu
			screen += CurrentMenu
			SetInputFocus(MainMenuObj)
		EnterItemTypesMenu()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = ItemTypesMenu
			screen += CurrentMenu
		EnterMap()
			ClearInputFocus()
			screen -= CurrentMenu
			mob.loc = locate(1,1,1)
			ScreenOutput(world,"[mob.name] has entered the map!")
			// ScreenOutput(src,"To chat press the 'c' key.")
		ViewMessage()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = ViewMessageScreen
			screen += CurrentMenu
		EnterNewMenu()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = NewMenu
			screen += CurrentMenu
			SetInputFocus(NewMenuObj)
		InputDemo()
			ClearInputFocus()
			screen -= CurrentMenu
			CurrentMenu = InputDemo
			screen += CurrentMenu
		ViewIntro()
			ClearInputFocus()
			Intro()
		Teleport(x as num|null,y as num|null,z as num|null)
			mob.loc = locate(x,y,z)
		ChangeHSpacing()
			var/hs = 2
			if(am == 0)
				am = 1
				while(hs < 20)
					hs += 2
					Font3.SetSpacing(hs,2)
					Font3.Update()
					sleep(1)
				while(hs > 2)
					hs -= 2
					Font3.SetSpacing(hs,2)
					Font3.Update()
					sleep(1)
				am = 0
		Host()
			if(HostDemoIO != null)
				var/port = text2num(HostDemoIO.GetText())
				if(port != null)
					var/status = world.OpenPort(port)
					if(status)
						alert("Connection Opened!")
						EnterMainMenu()
					else
						alert("Unable to open connection.")
				else
					alert("Unable to open connection.")
		GetDataInput()
			alert(InputDemoIO.GetText())
		Chat()
			if(IOFocus == null && mob.loc != null)
				var/TextObj/TO = new("Say:",Font4,"#FF0",0xFF,0)
				var/InputObj/IO = new(null,Font4,"#FF0",0xFF,40,TEXT,0x00,"#C0C0C0","#808080","SendChat")
				TO.SetScreenLoc(3,0,15,18)
				IO.SetScreenLoc(4,0,15,16)
				IO.layer = MOB_LAYER+1
				DataScreen2 += TO
				screen += TO
				screen += IO
				IO.SetCursor()
				SetInputFocus(IO)
		SendChat()
			screen -= DataScreen2
			DataScreen2 = new()
			var/msg = IOFocus.GetText()
			if(msg != null && msg != "")
				ScreenOutput(world,"[mob.name]: [msg]")
			var/InputObj/IO = IOFocus
			ClearInputFocus()
			del IO