var
	const
		SBYIO_DEFAULTFONT = 'HCANSIFont.dmi' // Use this constant if you want to use the default fontset.

		OUTLINE = 0x01
		FILL = 0x02
		HICON = 0x04

		TEXT = 0x00
		NUM = 0x01

		MVSPACING = 0x00
		MHSPACING = 0x01
		// MVHSPACING = 0x02
		// MHVSPACING = 0x03

FontObj
	parent_type = /icon
	var
		cwidth = 0
		cheight = 0
		hspacing = 0
		vspacing = 0
		list
			textobjs = new()
	New(fontfile,cwidth,cheight,hspacing,vspacing)
		src.icon = fontfile
		if(cwidth > 0)
			src.cwidth = cwidth
		else
			src.cwidth = Width()
		if(cheight > 0)
			src.cheight = cheight
		else
			src.cheight = Height()
		src.hspacing = hspacing
		src.vspacing = vspacing
	proc
		SetSize(cwidth,cheight)
			if(cwidth > 0)
				src.cwidth = cwidth
			else
				src.cwidth = Width()
			if(cheight > 0)
				src.cheight = cheight
			else
				src.cheight = Height()
		SetSpacing(hspacing,vspacing)
			src.hspacing = hspacing
			src.vspacing = vspacing
		Update()
			for(var/TextObj/TO in textobjs)
				TO.ChangeText(null)

TextObj
	parent_type = /obj
	var
		alpha = 0xFF
		color
		FontObj/font
		icon/TOI
	New(text,FontObj/font,color,alpha,mopacity)
		src.font = font
		src.font.textobjs += src
		src.color = color
		src.alpha = alpha
		src.mouse_opacity = mopacity
		src.ChangeText(text)
	proc
		ChangeText(text)
			if(src.text != text && text != null)
				src.text = text
			TOI = new('Special.dmi')
			var/lines = 1
			var/ccpos = 0
			var/cnlpos = findtext(src.text,"\n")
			var/mwidth = 0
			while(cnlpos != 0)
				if(ccpos == 0)
					ccpos = 1
				var/cwidth = cnlpos-ccpos
				if(cwidth > mwidth)
					mwidth = cwidth
				lines++
				ccpos = cnlpos+1
				cnlpos = findtext(src.text,"\n",ccpos)
			if(lines == 1)
				mwidth = length(src.text)
			var/iconwidth = (mwidth*(font.cwidth+font.hspacing))-font.hspacing
			var/iconheight = (lines*(font.cheight+font.vspacing))-font.vspacing
			TOI.Scale(iconwidth,iconheight)
			var/cipos = 0
			var/cline = 1
			for(var/C = 1; C <= length(src.text); C++)
				var/char = copytext(src.text,C,C+1)
				if(char == "\n")
					cline++
					cipos = 0
					continue
				var/icon/ichar = new(font,char)
				ichar.Scale(font.cwidth,font.cheight)
				TOI.Blend(ichar,ICON_OR,(cipos*(font.cwidth+font.hspacing))+1,((lines-cline)*(font.cheight+font.vspacing))+1)
				cipos++
			TOI.Blend(color)
			if(alpha == 0xFF)
				icon = TOI
			else
				var/icon/ATOI = new('Special.dmi')
				ATOI.Scale(TOI.Width(),TOI.Height())
				ATOI.Blend(TOI,ICON_OR)
				ATOI.Blend(rgb(0x00,0x00,0x00,alpha))
				icon = ATOI
		SetColor(color)
			src.TOI.Blend(src.color,ICON_SUBTRACT)
			src.color = color
			src.TOI.Blend(src.color)
			src.icon = src.TOI
		SetAlpha(alpha)
			src.alpha = alpha
			if(src.alpha < 0xFF)
				var/icon/ATOI = new('Special.dmi')
				ATOI.Scale(src.TOI.Width(),src.TOI.Height())
				ATOI.Blend(src.TOI,ICON_OR)
				ATOI.Blend(rgb(0x00,0x00,0x00,src.alpha))
				src.icon = ATOI
			else
				src.icon = src.TOI
		SetMapLoc(x,y,z)
			loc = locate(x,y,z)
		SetScreenLoc(x,px,y,py)
			screen_loc = "[x]:[px],[y]:[py]"

ItemTextObj
	parent_type = /TextObj
	var
		style
		thcolor
		ohcolor
		ihcolor
		command
		icon/hicon
		id
		MenuObj/MO
		icon/HBG
	New(text,FontObj/font,color,alpha,style,thcolor,ohcolor,ihcolor,command,hicon)
		src.style = style
		src.thcolor = thcolor
		src.command = command
		if(src.style & HICON)
			src.hicon = new(hicon)
		if(!(src.style & OUTLINE || src.style & FILL))
			..(text,font,color,alpha,2)
		else
			src.font = font
			src.font.textobjs += src
			src.color = color
			src.alpha = alpha
			src.ohcolor = ohcolor
			if(src.style & FILL)
				src.ihcolor = ihcolor
			src.mouse_opacity = 2
			src.ChangeText(text)
	MouseEntered()
		if(MO != null)
			if(!MO.keyboardonly)
				Select()
		else
			Select()
	MouseExited()
		if(MO != null)
			if(!MO.keyboardonly)
				Unselect()
		else
			Unselect()
	Click()
		..()
		if(MO != null)
			if(!MO.keyboardonly)
				Command()
		else
			Command()
	ChangeText(text)
		if(src.text != text && text != null)
			src.text = text
		TOI = new('Special.dmi')
		var/lines = 1
		var/ccpos = 0
		var/cnlpos = findtext(src.text,"\n")
		var/mwidth = 0
		while(cnlpos != 0)
			if(ccpos == 0)
				ccpos = 1
			var/cwidth = cnlpos-ccpos
			if(cwidth > mwidth)
				mwidth = cwidth
			lines++
			ccpos = cnlpos+1
			cnlpos = findtext(src.text,"\n",ccpos)
		if(lines == 1)
			mwidth = length(src.text)
		var/iconwidth = 0
		var/iconheight = 0
		var/startx = 1
		var/starty = 1
		if(style & OUTLINE || style & FILL)
			iconwidth = (mwidth*(font.cwidth+font.hspacing))-font.hspacing+4
			iconheight = (lines*(font.cheight+font.vspacing))-font.vspacing+4
		else
			iconwidth = (mwidth*(font.cwidth+font.hspacing))-font.hspacing
			iconheight = (lines*(font.cheight+font.vspacing))-font.vspacing
		if(style & HICON && hicon != null)
			iconwidth += hicon.Width() + font.hspacing
			startx += hicon.Width() + font.hspacing
			var/otsize = (lines*(font.cheight + font.vspacing))-font.vspacing
			if(hicon.Height() < otsize)
				var/midpoint = round((hicon.Height() + otsize) / 2)
				var/incy = midpoint - hicon.Height()
				starty += incy
		TOI.Scale(iconwidth,iconheight)
		var/cipos = 0
		var/cline = 1
		if((style & OUTLINE || style & FILL))
			HBG = new('Special.dmi')
			HBG.Scale(iconwidth-(startx-1),iconheight)
			if(style & OUTLINE)
				HBG.DrawBox(ohcolor,1,1,iconwidth-(startx-1),iconheight)
			if(!(style & FILL))
				HBG.DrawBox(null,2,2,iconwidth-(startx-1)-1,iconheight-1)
			else
				if(style & OUTLINE)
					HBG.DrawBox(ihcolor,2,2,iconwidth-(startx-1)-1,iconheight-1)
				else
					HBG.DrawBox(ihcolor,1,1,iconwidth-(startx-1),iconheight)
		for(var/C = 1; C <= length(src.text); C++)
			var/char = copytext(src.text,C,C+1)
			if(char == "\n")
				cline++
				cipos = 0
				continue
			var/icon/ichar = new(font,char)
			ichar.Scale(font.cwidth,font.cheight)
			if(style & OUTLINE || style & FILL)
				TOI.Blend(ichar,ICON_OR,(cipos*(font.cwidth+font.hspacing))+(startx+2),((lines-cline)*(font.cheight+font.vspacing))+3)
			else
				TOI.Blend(ichar,ICON_OR,(cipos*(font.cwidth+font.hspacing))+startx,((lines-cline)*(font.cheight+font.vspacing))+1)
			cipos++
		var/icon/TOIF = new(TOI)
		TOIF.Blend(thcolor)
		TOI.Blend(color)
		if((style & OUTLINE) || (style & FILL))
			TOIF.Blend(HBG,ICON_UNDERLAY,startx)
		if(style & HICON)
			if((style & OUTLINE) || (style & FILL))
				TOIF.Blend(hicon,ICON_UNDERLAY,1,starty+2)
			else
				TOIF.Blend(hicon,ICON_UNDERLAY,1,starty)
		TOI.Insert(TOIF,"Focus",null,0,0,null)
		icon = TOI
	SetColor(color)
		var/icon/NTOI = new(TOI)
		var/icon/TOIF = new(NTOI,"")
		TOIF.Blend(src.color,ICON_SUBTRACT)
		src.color = color
		TOIF.Blend(src.color)
		NTOI.Insert(TOIF,"",null,0,0,0)
		TOI = NTOI
		icon = TOI
	proc
		SetHighlightColor(thcolor,ohcolor,ihcolor)
			var/icon/NTOI = new(TOI)
			var/icon/TOIF = new(NTOI,"")
			var/startx = 1
			var/starty = 1
			if(style & HICON && hicon != null)
				startx += hicon.Width()
				if(hicon.Height() < font.cheight)
					var/midpoint = round((hicon.Height() + font.cheight) / 2)
					var/incy = midpoint - hicon.Height()
					starty += incy
			TOIF.Blend(src.color,ICON_SUBTRACT)
			src.thcolor = thcolor
			TOIF.Blend(src.thcolor)
			if((style & OUTLINE) || (style & FILL))
				var/icon/NHBG = new('Special.dmi')
				var/bgwidth = TOIF.Width() - (startx-1)
				var/bgheight = TOIF.Height()
				NHBG.Scale(bgwidth,bgheight)
				if(ohcolor != null)
					src.ohcolor = ohcolor
					if(style & OUTLINE)
						NHBG.DrawBox(src.ohcolor,1,1,bgwidth,bgheight)
					if(!(style & FILL))
						NHBG.DrawBox(null,2,2,bgwidth-1,bgheight-1)
				if(ihcolor != null)
					src.ihcolor = ihcolor
					if(!(style & OUTLINE))
						NHBG.DrawBox(src.ihcolor,1,1,bgwidth,bgheight)
					else
						NHBG.DrawBox(src.ihcolor,2,2,bgwidth-1,bgheight-1)
				TOIF.Blend(HBG,ICON_UNDERLAY,startx)
			if(style & HICON)
				if((style & OUTLINE) || (style & FILL))
					TOIF.Blend(hicon,ICON_UNDERLAY,1,starty+2)
				else
					TOIF.Blend(hicon,ICON_UNDERLAY,1,starty)
			NTOI.Insert(TOIF,"Focus",null,0,0,0)
			TOI = NTOI
			icon = TOI
		Select()
			icon_state = "Focus"
			if(MO != null)
				if(MO.cid != id)
					if(MO.cid > 0)
						var/ItemTextObj/PIT = MO.menulist[MO.cid]
						PIT.Unselect()
					MO.cid = id
		Unselect()
			icon_state = ""
		Command()
			var/list/cmd = new()
			cmd["command"] = "[command]"
			winset(usr,null,list2params(cmd))

MenuObj
	parent_type = /InputObj
	var
		hspacing
		vspacing
		thcolor
		ohcolor
		ihcolor
		icon/hicon
		keyboardonly
		spacingmode
		cid = 0
		list
			menulist = new()
	New(FontObj/font,vspacing,style,color,alpha,thcolor,ohcolor,ihcolor,hicon,keyboardonly,hspacing,spacingmode)
		src.font = font
		src.hspacing = hspacing
		src.vspacing = vspacing
		src.style = style
		src.color = color
		src.alpha = alpha
		src.thcolor = thcolor
		src.ohcolor = ohcolor
		src.ihcolor = ihcolor
		src.hicon = new(hicon)
		src.keyboardonly = keyboardonly
		src.spacingmode = spacingmode
		if(src.keyboardonly > 1)
			src.keyboardonly = 1
		else if(src.keyboardonly < 0)
			src.keyboardonly = 0
	proc
		AddItem(text,command)
			var/ItemTextObj/NI = new(text,font,color,alpha,style,thcolor,ohcolor,ihcolor,command,hicon)
			menulist += NI
			NI.id = length(menulist)
			NI.MO = src
			if(NI.id == 1 && keyboardonly)
				NI.Select()
		SetMenuLoc(sx,spx,sy,spy)
			var/mipos = 0
			var/diwidth = 0
			var/diheight = 0
			var/cspx = spx
			if(isnum(world.icon_size))
				diwidth = world.icon_size
				diheight = world.icon_size
			else
				var/cirhpos = findtext(world.icon_size,"x",1)
				var/cirvpos = findtext(world.icon_size,"x",1)+1
				diwidth = text2num(copytext(world.icon_size,1,cirhpos))
				diheight = text2num(copytext(world.icon_size,cirvpos))
			for(var/ItemTextObj/ITO in menulist)
				var/nsx = sx
				var/nspx = cspx
				var/nsy = sy
				var/nspy = spy-(mipos*(font.cheight+vspacing))
				while(nspx > diwidth)
					nspx -= diwidth
					nsx++
				while(nspy < 0)
					nspy += diheight
					nsy--
				cspx += ((font.cwidth+font.hspacing)*length(ITO.text))+hspacing
				if((style & HICON) && hicon != null)
					cspx += hicon.Width()+font.hspacing
				switch(spacingmode)
					if(MVSPACING)
						ITO.SetScreenLoc(sx,spx,nsy,nspy)
					if(MHSPACING)
						ITO.SetScreenLoc(nsx,nspx,sy,spy)
				mipos++
		GetMenuList()
			return menulist
		GetSelectedMenuItem()
			if(cid != 0)
				return menulist[cid]
			else
				return null

InputObj
	parent_type = /TextObj
	var
		itype
		style
		ocolor
		icolor
		command
		length = 0
		cpos = 1
		icon/IBG
	New(text,FontObj/font,color,alpha,length,itype,style,ocolor,icolor,command)
		src.font = font
		src.font.textobjs += src
		src.color = color
		src.alpha = alpha
		src.mouse_opacity = 2
		src.length = length
		src.style = style
		src.itype = itype
		src.command = command
		var/iconwidth = ((src.length+1)*(src.font.cwidth+src.font.hspacing+2))
		var/iconheight = src.font.cheight+4
		src.TOI = new('Special.dmi')
		src.TOI.Scale(iconwidth,iconheight)
		if((src.style & OUTLINE) || (src.style & FILL))
			src.IBG = new('Special.dmi')
			src.IBG.Scale(iconwidth,iconheight)
			if(src.style & OUTLINE)
				src.ocolor = ocolor
				src.IBG.DrawBox(src.ocolor,1,1,iconwidth,iconheight)
			if(src.style & FILL)
				src.icolor = icolor
				src.IBG.DrawBox(src.icolor,2,2,iconwidth-1,iconheight-1)
			src.TOI.Insert(IBG,"")
		src.icon = src.TOI
		src.ChangeText(text)
	Click(location,control,params)
		var/list/pr = params2list(params)
		var/client/C = usr.client
		var/iconx = text2num(pr["icon-x"])
		var/ischk = 0
		cpos = 1
		if(icon_state == "Focus")
			ischk = 1
		C.SetInputFocus(src)
		for(var/cp = 1; cp <= length(text); cp++)
			var/iconxpos = ((cp-1)*(C.IOFocus.font.cwidth+C.IOFocus.font.hspacing+2))
			var/niconpos = (cp*(C.IOFocus.font.cwidth+C.IOFocus.font.hspacing+2))
			if(iconx >= iconxpos && iconx <= niconpos)
				break
			cpos++
		SetCursor()
		if(ischk == "Focus")
			icon_state = "Focus"
	ChangeText(text)
		if(src.text != text)
			if(src.itype == TEXT || (src.itype == NUM && text2num(text) != null))
				src.text = text
				for(var/c = 1; c <= length(src.text); c++)
					var/char = copytext(src.text,c,c+1)
					AddChar(char)
	proc
		GetText()
			return text
		SetCursor()
			var/icon/cchar = new(font,"_")
			var/icon/CTOI = new('Special.dmi')
			var/icon/NTOI = new(TOI)
			var/iconpos = ((cpos-1)*(font.cwidth+font.hspacing+2))+3
			cchar.Scale(font.cwidth,font.cheight)
			cchar.Blend(color)
			CTOI.Scale(NTOI.Width(),NTOI.Height())
			CTOI.Blend(NTOI,ICON_OR)
			NTOI.Insert(CTOI,"Focus",null,1,0,5)
			CTOI.DrawBox(icolor,iconpos,3,(iconpos+(font.cwidth+font.hspacing+2))-(font.hspacing+2),(font.cheight+4)-2)
			CTOI.Blend(cchar,ICON_OVERLAY,iconpos,3)
			NTOI.Insert(CTOI,"Focus",null,2,0,5)
			TOI = NTOI
			icon = TOI
		AddChar(char)
			if(cpos <= length)
				var/ischk = 0
				if(icon_state == "Focus")
					ischk = 1
					icon_state = ""
				var/icon/cchar = new(font,char)
				cchar.Scale(font.cwidth,font.cheight)
				cchar.Blend(color)
				var/iconpos = ((cpos-1)*(font.cwidth+font.hspacing+2))+3
				if(cpos <= length(text))
					TOI.DrawBox(icolor,iconpos,3,(iconpos+(font.cwidth+font.hspacing+2))-(font.hspacing+2),(font.cheight+4)-2)
					TOI.Blend(cchar,ICON_OVERLAY,iconpos,3)
					var/ntext = copytext(text,1,cpos)
					ntext += char
					if(cpos < length(text))
						ntext += copytext(text,cpos+1)
					text = ntext
				else
					TOI.Blend(cchar,ICON_OVERLAY,iconpos,3)
					text += char
				cpos++
				SetCursor()
				if(ischk == 1)
					icon_state = "Focus"
		DeleteChar(cpflag)
			if(cpos > 1 || ((cpflag & 0x01) && length(text) > 0))
				var/ischk = 0
				if(icon_state == "Focus")
					ischk = 1
					icon_state = ""
				if(!(cpflag & 0x01))
					cpos--
				var/iconpos = ((cpos-1)*(font.cwidth+font.hspacing+2))+3
				var/miconpos = ((length(text)-1)*(font.cwidth+font.hspacing+2))+3
				var/ntext
				TOI.DrawBox(icolor,iconpos,3,(miconpos+(font.cwidth+font.hspacing+2))-(font.hspacing+2),(font.cheight+4)-2)
				if(cpos < length(text))
					ntext = copytext(text,cpos+1,length(text)+1)
				text = copytext(text,1,cpos)
				if(ntext != null)
					var/tcpos = cpos
					for(var/ccpos = 1; ccpos <= length(ntext); ccpos++)
						var/char = copytext(ntext,ccpos,ccpos+1)
						AddChar(char)
					cpos = tcpos
				SetCursor()
				if(ischk == 1)
					icon_state = "Focus"
		CursorLeft()
			if(cpos > 1)
				cpos--
				SetCursor()
		CursorRight()
			if(cpos <= length(text))
				cpos++
				SetCursor()
		Command()
			var/list/cmd = new()
			cmd["command"] = "[command]"
			winset(usr,null,list2params(cmd))

atom
	Click()
		..()
		if(usr.client.IOFocus != null)
			if(!istype(usr.client.IOFocus,/MenuObj))
				usr.client.ClearInputFocus()

client
	var
		InputObj/IOFocus
		cwindow
		cmacro
	New()
		..()
		mob.loc = null
		cwindow = winget(src,null,"focus")
		var/cwndchk = findtext(cwindow,".")
		if(cwndchk != 0)
			cwindow = copytext(cwindow,1,cwndchk)
		cmacro = winget(src,cwindow,"macro")
		winclone(src,"macro","inputmodemacro")
		SetKeyInputMacro("UAKR","NORTH","Up")
		SetKeyInputMacro("DAKR","SOUTH","Down")
		SetKeyInputMacro("LAKR","WEST","Left")
		SetKeyInputMacro("RAKR","EAST","Right")
		SetKeyInputMacro("BKKR","BACK","Back")
		SetKeyInputMacro("DKKR","DELETE","Delete")
		SetKeyInputMacro("SPKR","SPACE"," ")
		SetKeyInputMacro("ENKR","RETURN","Enter")
		SetKeyInputMacro("GAKR","`","`")
		SetKeyInputMacro("TLKR","SHIFT+`","~")
		SetKeyInputMacro("HPKR","-","-")
		SetKeyInputMacro("UDKR","SHIFT+-","_")
		SetKeyInputMacro("EQKR","=","=")
		SetKeyInputMacro("LBRKR","\[","\[")
		SetKeyInputMacro("LBCKR","SHIFT+\[","{")
		SetKeyInputMacro("RBRKR","]","]")
		SetKeyInputMacro("RBCKR","SHIFT+]","}")
		SetKeyInputMacro("SBKR","\\","\\\\")
		SetKeyInputMacro("CAKR","SHIFT+\\","|")
		SetKeyInputMacro("SCKR",";",";")
		SetKeyInputMacro("COKR","SHIFT+;",":")
		SetKeyInputMacro("AEKR","'","'")
		SetKeyInputMacro("QOKR","SHIFT+'","\\\"")
		SetKeyInputMacro("CMKR",",",",")
		SetKeyInputMacro("LTKR","SHIFT+,","<")
		SetKeyInputMacro("PDKR",".",".")
		SetKeyInputMacro("GTKR","SHIFT+.",">")
		SetKeyInputMacro("SFKR","/","/")
		SetKeyInputMacro("QMKR","SHIFT+/","?")
		SetKeyInputMacro("PLKR","SHIFT+=","+")
		SetKeyInputMacro("0SKR","SHIFT+0",")")
		SetKeyInputMacro("1SKR","SHIFT+1","!")
		SetKeyInputMacro("2SKR","SHIFT+2","@")
		SetKeyInputMacro("3SKR","SHIFT+3","#")
		SetKeyInputMacro("4SKR","SHIFT+4","$")
		SetKeyInputMacro("5SKR","SHIFT+5","%")
		SetKeyInputMacro("6SKR","SHIFT+6","^")
		SetKeyInputMacro("7SKR","SHIFT+7","&")
		SetKeyInputMacro("8SKR","SHIFT+8","*")
		SetKeyInputMacro("9SKR","SHIFT+9","(")
		for(var/nK = 0; nK <= 9; nK++)
			SetKeyInputMacro("[nK]KR","[nK]","[nK]")
		for(var/uK = text2ascii("A"); uK <= text2ascii("Z"); uK++)
			var/cK = ascii2text(uK)
			SetKeyInputMacro("[cK]SKR","SHIFT+[cK]","[cK]")
		for(var/lK = text2ascii("a"); lK <= text2ascii("z"); lK++)
			var/cK = ascii2text(lK)
			SetKeyInputMacro("[cK]KR","[cK]","[cK]")
	proc
		SetKeyInputMacro(macroname,key,input)
			var/list/keyi = new()
			keyi["parent"] = "inputmodemacro"
			keyi["name"] = "[key]+REP"
			keyi["command"] = "KeyInput \"[input]\""
			winset(src,macroname,list2params(keyi))
		SetInputFocus(InputObj/IO)
			cwindow = winget(src,null,"focus")
			while(cwindow == "")
				sleep(1)
				cwindow = winget(src,null,"focus")
			var/cwndchk = findtext(cwindow,".")
			if(cwndchk != 0)
				cwindow = copytext(cwindow,1,cwndchk)
			if(winget(src,null,"macro") != "inputmodemacro")
				winset(src,cwindow,"macro=\"inputmodemacro\"")
			if(IOFocus != IO)
				if(IOFocus != null)
					IOFocus.icon_state = ""
				IOFocus = IO
				if(istype(IOFocus,/MenuObj))
					var/MenuObj/MO = IOFocus
					if(length(MO.menulist) > 0 && MO.keyboardonly)
						var/ItemTextObj/CIT = MO.menulist[1]
						CIT.Select()
				else
					IOFocus.icon_state = "Focus"
		ClearInputFocus()
			if(IOFocus != null)
				IOFocus.icon_state = ""
				if(istype(IOFocus,/MenuObj))
					var/MenuObj/MO = IOFocus
					var/ItemTextObj/ITO = MO.GetSelectedMenuItem()
					if(ITO != null)
						ITO.Unselect()
				IOFocus = null
				cwindow = winget(src,null,"focus")
				var/cwndchk = findtext(cwindow,".")
				if(cwndchk != 0)
					cwindow = copytext(cwindow,1,cwndchk)
				winset(src,cwindow,"macro=\"[cmacro]\"")
	verb
		KeyInput(c as text)
			set hidden = 1
			if(IOFocus != null)
				if(!istype(IOFocus,/MenuObj))
					if(c == "Left")
						IOFocus.CursorLeft()
					else if(c == "Right")
						IOFocus.CursorRight()
					else if(c == "Back")
						IOFocus.DeleteChar(0)
					else if(c == "Delete")
						IOFocus.DeleteChar(1)
					else if(c == "Enter")
						IOFocus.Command()
					else if(length(c) == 1)
						var/char = c
						if(IOFocus.itype == NUM)
							var/v = text2num(char)
							if(v == null)
								char = null
						if(char != null)
							IOFocus.AddChar(char)
				else
					var/MenuObj/MO = IOFocus
					var/ItemTextObj/IT
					if(c != "Enter")
						var/pid = MO.cid
						switch(MO.spacingmode)
							if(MVSPACING)
								if(c == "Up")
									pid--
									if(pid < 1)
										pid = length(MO.menulist)
								else if(c == "Down")
									pid++
									if(pid > length(MO.menulist))
										pid = 1
							if(MHSPACING)
								if(c == "Left")
									pid--
									if(pid < 1)
										pid = length(MO.menulist)
								else if(c == "Right")
									pid++
									if(pid > length(MO.menulist))
										pid = 1
						IT = MO.menulist[pid]
						IT.Select()
					else
						if(MO.cid > 0)
							IT = MO.menulist[MO.cid]
							IT.Command()